#include <stdio.h>
#include <gb.h>
#include <rand.h>
#include <time.h>
#include "drop.h"

#include "font.c"

// these variable can only be used if no other function
// is being called while you are using them
UBYTE temp1, temp2; 

UBYTE players = 2;
UBYTE extra1 = 0;
UBYTE extra2 = 0;
UBYTE sound = NO;

// these are variable to do with player input
UBYTE joy,last_joy;
UBYTE left_initial,right_initial,down_initial;
UBYTE left_secondary,right_secondary,down_secondary;
UBYTE left_timer,right_timer,down_timer;
UBYTE left_rep,right_rep,down_rep;

long sc_score, sc_lines, sc_pieces;
UBYTE sc_cheating, sc_gametype, sc_doiwin, sc_bonus_timer;

UBYTE piece[4]; // a 2x2 matrix of the piece colors
// 0,1
// 2,3
UBYTE nextpiece[4]; // the next piece that will appear

UBYTE list[100][2];

UBYTE board[BOARD_MAX_X][BOARD_MAX_Y];

int nextincrease;
UBYTE linesperlevel;

UBYTE xoffset;
UBYTE nextxpos,nextypos;
UBYTE posx,posy;
UBYTE dead;
UBYTE length;
UBYTE speed;
UBYTE extratimer;
UBYTE extrax,extray;
UBYTE countdown;

// game options
UBYTE gametype;
UBYTE shownext;
UBYTE startlines;
UBYTE startspeed;
UBYTE maxspeed;
UBYTE resetspeed;
UBYTE linesperlevel;
UBYTE wantstoplay;
UBYTE music;
UBYTE sound;
UBYTE cheating;


void init_score( void )
{
	sc_score = 0;
	sc_lines = 0;
	sc_doiwin = NO;
	sc_pieces = 1;
	sc_cheating = 0;
	sc_gametype = FAST;
}

void create_board( void )
{
  UBYTE x,y;
	

	for (x=0;x<BOARD_MAX_X;x++)
	{
		for (y=0;y<BOARD_MAX_Y;y++)
		{
			if (y>BOARD_MAX_Y-startlines-3 && y<BOARD_MAX_Y-2 && x>0 &&
					x<BOARD_MAX_X-1 &&  (cheating&BOARD) != 0)
			{
				if (rand()%3 == 1)
				{
					board[x][y] = rand()%NUM_COLORS+1;
					displaysquare(x,y);
				}
				else
				{
					board[x][y]=0;
				}
			}
			else if (y>BOARD_MAX_Y-startlines-3 &&
					y<BOARD_MAX_Y-2 &&
					y % 2 ==1 &&
					x > 0 &&
					x < BOARD_MAX_X-1)
			{
				board[x][y]=rand()%NUM_COLORS+1;
				displaysquare(x,y);
			}
			else
			{
				board[x][y]=0;
			}
		}
	}
}

void rotate ( void )
{
	if (piece[1] != 0)
	{
		piece[2] = piece[0];
		piece[0] = piece[1];
		piece[1] = 0;
	}
	else
	{
		piece[1] = piece[2];
		piece[2] = 0;
	}
}

UBYTE canrotate ( void )
{
  if (posy == 1)
    return 1;

	if (piece[2] != 0)
	{
		if (posx == BOARD_MAX_X-2)
			return 1;
		return board[posx+1][posy];
	}
	if (posy==BOARD_MAX_Y-3)
		return 1;
	return board[posx][posy+1];
}

UBYTE canleft ( void )
{
	temp1 = 0;

	if (posx == 1)
		return 1;
	temp1 = board[posx-1][posy];
	if( piece[1]!=0)
	{
		return temp1;
	}
	else
		return temp1 + board[posx-1][posy+1];
}

UBYTE canright ( void )
{
	if (piece[1] != 0)
	{
		if (posx==BOARD_MAX_X-3)
			return 1;
		return board[posx+2][posy];
	}
	else
	{
		if (posx == BOARD_MAX_X-2)
			return 1;
		return board[posx+1][posy] + board[posx+1][posy+1];
	}
}

UBYTE candrop ( void )
{

	if (piece[2] != 0)
	{
		if (posy == BOARD_MAX_Y-4)
			return 1;
		return board[posx][posy+2];
	}
	else
	{
		temp1 = board[posx][posy+1];
		temp1 += board[posx+1][posy+1];
		if (posy == BOARD_MAX_Y-3)
			temp1 = 1;
		return temp1;
	}
}

UBYTE inlist (UBYTE x, UBYTE y, UBYTE len)
/* 0 = in list, 1= not in list */
{
	int temp1;
	for (temp1 = 0 ; temp1 <= len ; temp1++)
	{
		if ((list[temp1][0] == x) && (list[temp1][1] == y))
			return 0;
	}
	return 1;
}

void initlist( void )
{
	for (temp1 = 0 ; temp1 < 100 ; temp1++)
	{
		list[temp1][0]=0;
		list[temp1][1]=0;
	}
}

int checkpos (int posx,int posy,int length)
{
	UBYTE c,n;
	UBYTE color;
	UBYTE x,y;
	UBYTE sc = 0;

	color = board[posx][posy];
	c=n=0;

	if (color == 0)
		return 0;

	list[n][0]=posx;
	list[n][1]=posy;

	while (c <= n)
	{
		x = list[c][0];
		y = list[c][1];

		if (board[x-1][y] == color)
		{
			if (inlist(x-1,y,n)==1)
			{
				n++;
				list[n][0]=x-1;
				list[n][1]=y;
			}
		}
		if (board[x+1][y] == color)
		{
			if (inlist(x+1,y,n)==1)
			{
				n++;
				list[n][0]=x+1;
				list[n][1]=y;
			}
		}
		if (board[x][y-1] == color)
		{
			if (inlist(x,y-1,n)==1)
			{
				n++;
				list[n][0]=x;
				list[n][1]=y-1;
			}
		}
		if (board[x][y+1] == color)
		{
			if (inlist(x,y+1,n)==1)
			{
				n++;
				list[n][0]=x;
				list[n][1]=y+1;
			}
		}
		c++;
	}
	if (n>length)
	{
		c=n;
		delay(20);

		for (n=0;c>=n;n++)
		{
			if (sound)
			{
				play_sound(0);
			}
			x=list[n][0];
			y=list[n][1];
			erasesquare(x,y);
			sc = sc+n+1;
			board[x][y]=0;
		}
		return sc;
	}

	return 0;

}

int piecetoboard (int x, int y,int length)
{
	UBYTE sc1=0;
	UBYTE sc2=0;
	UBYTE got_a_line = NO;
	UBYTE total= 0;

	board[x][y] = piece[0];

	if (piece[2] != 0)
	{
		board[x][y+1] = piece[2];
	}
	else
	{
		board[x+1][y] = piece[1];
	}
	sc1 = checkpos(x,y,length);

	if (piece[2]!=0)
	{
		sc2 = checkpos(x,y+1,length);
	}
	else
	{
		sc2 = checkpos(x+1,y,length);
	}

	total = sc1+sc2;

	if (sc1>0 && sc2>0)
	{
		total=total*4;
  	//print_str("Two Lines * 4",10,160,100,4,0);
		sc_bonus_timer=35;
	}

	if (sc1>0)
	{
		sc_lines++;
		got_a_line=YES;
	}

	if (sc2>0)
	{
		sc_lines++;
		got_a_line=YES;
	}

	if (!shownext)
		total = total + (total>>3);

	sc_score +=total;

	if (total >0)
	{
    // put the total up on the screen
		// sc_bonus_timer=35;
 	}

	return got_a_line;
}

void newpiece (void)
{
	nextpiece [0] = rand()%NUM_COLORS+1;
	nextpiece [1] = nextpiece[3] = 0;
	nextpiece [2] = rand()%NUM_COLORS+1;
}

void trydown (void)
{
	if (candrop() == 0)
	{
		erasepiece(posx,posy);
		posy++;
		displaypiece(posx,posy);
	}
  else
  {
		countdown = speed +1;
		piecefall();
    down_rep = 2;
    // give the player lots of time before the next piece drops
    down_timer = down_secondary+1; 
  }
}

void player_input (void)
{
  joy = joypad();

	if (joy & J_LEFT)
	{
		if (!(last_joy & J_LEFT))
    {
      if (canleft() == 0)
		  {
				erasepiece(posx,posy);
				posx--;
				displaypiece(posx,posy);
		  }
      left_timer = 0;
      left_rep = 1;
	  }
    else 
    {
      if (left_rep == 1) 
      {
        left_timer++;
        if (left_timer == left_initial)
        {
          left_timer = 0;
          left_rep = 2;
          if (canleft() == 0)
		      {
				    erasepiece(posx,posy);
				    posx--;
				    displaypiece(posx,posy);
		      }
        } 
      }
      else // left_rep = 2 
      {
        left_timer++;
        if (left_timer == left_secondary)
        {
          left_timer = 0;
          if (canleft() == 0)
		      {
				    erasepiece(posx,posy);
				    posx--;
				    displaypiece(posx,posy);
		      }
        } 
      }
    }
  }

	if (joy & J_RIGHT) 
	{
    if (!(last_joy & J_RIGHT))
    {
  		if (canright() == 0)
	  	{
		  	erasepiece(posx,posy);
			  posx++;
			  displaypiece(posx,posy);
		  }
      right_rep = 1;
      right_timer = 0;
	  }
    else
    {
      if (right_rep == 1)
      {
        right_timer++;
        if (right_timer == right_initial)
        {
          right_timer = 0;
          right_rep = 2;
          if (canright() == 0)
		      {
				    erasepiece(posx,posy);
				    posx++;
				    displaypiece(posx,posy);
		      }
        }
      }
      else
      {
        right_timer++;
        if (right_timer == right_secondary)
        {
          right_timer = 0;
          if (canright() == 0)
		      {
				    erasepiece(posx,posy);
				    posx++;
				    displaypiece(posx,posy);
		      }
        }
      }
    }
  }

  if ((joy & J_A) && !(last_joy & J_A))
	{
	  if (canrotate() == 0)
	  {
			erasepiece(posx,posy);
			rotate ();
			displaypiece(posx,posy);
		}
	}

  if (joy & J_DOWN)
	{
    if (!(last_joy & J_DOWN))
    {
      trydown();
      down_timer = 0;
      down_rep = 1;
    }
    else
    {
      if (down_rep == 1)
      {
        down_timer ++;
        if (down_timer == down_initial)
        {
          trydown();
          down_rep = 2;
          down_timer = 0;
        }
      }
      else
      {
        down_timer ++;
        if (down_timer == down_secondary)
        {
          trydown();
          down_timer = 0;
        }
      }
    }
	}

  last_joy = joy;

}

void piecefall ( void )
{
	UBYTE did_score;

	erasepiece(posx, posy);
	if (candrop() == 0)
	{
		posy++;
		displaypiece(posx, posy);
	}
	else
	{
		displaypiece(posx, posy);
		sc_pieces++;
		did_score = piecetoboard(posx,posy,length);
		if (did_score == YES)
		{
			if (gametype == FAST && sc_lines>49)
			{
				sc_doiwin=YES;
				dead = YES;
			}
			if (sc_lines >= nextincrease)
			{
				speed = speed - 10;
				nextincrease += linesperlevel;

				if (speed < maxspeed)
				{
					speed = resetspeed;
					length++;
				}

				if (music)
				{
					if (speed == resetspeed)
					{
						ChangeTempo(3);
					}
					else if (speed ==5)
					{
						ChangeTempo(2);
					}
					else if (speed ==3)
					{
						ChangeTempo(1);
					}
				}

				displayspeed ();
			}

			displayscore ();

		}

		posx = 7;
		posy = 2;
    for ( temp1 = 0 ; temp1 < 4 ; temp1++)
  		piece[temp1] = nextpiece[temp1];
	
  	newpiece();
		if (shownext==YES)
			displaynextpiece();
		
    if ((board[7][3]!=0) || (board[7][2]!=0))
			dead=YES;
		displaypiece(posx, posy);
	}	
}

void update_board ()
{
	if (sc_bonus_timer > 0)
	{
		sc_bonus_timer--;
		if (sc_bonus_timer ==0)
		{
			//erase_bonus_text();
		}
	}

}

void init_board (UBYTE x)
{
  startspeed = 120;
  maxspeed = 30;
  resetspeed = 100;
  linesperlevel = 5;
  shownext = YES;
  
  if (x == J_A)
    startlines = 13;
  else
    startlines = 0;

  left_timer = right_timer = down_timer = 0;
  left_initial = right_initial = 20;
  down_initial = 15;
  left_secondary = right_secondary = down_secondary = 6;
  left_rep = right_rep = down_rep = 0;

	length = 2;
	nextincrease = linesperlevel;
	speed = startspeed;
	dead = NO;
	posx = 7;
	posy = 2;
	newpiece();
  for ( temp1 = 0 ; temp1 < 4 ; temp1++)
		piece[temp1] = nextpiece[temp1];
  	
  newpiece();

	init_score();

  create_board();

}

void play (UBYTE x)
{
	UBYTE loops = 0;

  //turn on the speakers

  // start the music


  init_board (x);

	initrand ((UWORD) clock());
  countdown = speed+1;

	displayspeed ();
	displayscore ();

	displaypiece (posx,posy);

	if (shownext)
	{
		displaynextpiece();
	}



	while (dead==NO)
	{
		loops ++;
	
  	player_input ();

    wait_vbl_done();
		// erase score board
  	update_board();
		loops=0;
		countdown--;
  	if (countdown == 0)
		{
			countdown = speed +1;
			piecefall();
		}
	}

  if (music)
  {
    ;// turn off the music
  }
	if (sound)
	{
	  ;	// turn off the sound
	}
}

void main ( void )
{
  UBYTE x;
  
  // load the font data
  set_win_data ((UBYTE)-128,128,font);

  set_bkg_data (1,1,font);
 
  check_cgb ();
 
  while (1 == 1) 
	{
  	x = title ();
    init_graphics ();
		play (x);
	}
}



static const unsigned char cEMPTY[] = 
{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0}; 
/* an empty line for the background */
static const unsigned char cEMPTYPAL[] = 
{ 7,0,0,0,0,0,0,0,0,0,0,0,0,0,7,7,7,7,7,7}; 

void empty_screen (void)
{
 
  HIDE_BKG;
  HIDE_SPRITES;

  VBK_REG = 0;

  for (temp1=0; temp1<40; temp1++)
  {
    move_sprite(temp1,0,200);
    set_sprite_prop (temp1,0);
  }

  for (temp1=0; temp1<20; temp1++)
  {
    set_bkg_tiles (0,temp1,20,1,(unsigned char *) &cEMPTY[0]);   
    set_win_tiles (0,temp1,20,1,(unsigned char *) &cEMPTY[0]);   

    VBK_REG = 1;
    set_bkg_tiles (0,temp1,20,1,(unsigned char *) &cEMPTYPAL[0]);   
    VBK_REG = 0;
  }

  move_bkg (0,0);
  
  SHOW_BKG;
  SHOW_SPRITES;
}

void init_graphics (void)
{
  empty_screen ();

  //  blank
  set_bkg_palette_entry(0,0,RGB(0,0,0)); 

  //  red
  set_bkg_palette_entry(1,0,RGB(31,0,0)); 

  // green
  set_bkg_palette_entry(2,0,RGB(0,31,0)); 

  // blue
  set_bkg_palette_entry(3,0,RGB(0,0,31)); 

  // purple
  set_bkg_palette_entry(4,0,RGB(31,0,31)); 

  // yellow
  set_bkg_palette_entry(5,0,RGB(0,31,31)); 

  // ??
  set_bkg_palette_entry(6,0,RGB(31,31,0)); 

  // score text and shit
  set_bkg_palette_entry(7,0,RGB(0,0,0)); 
  set_bkg_palette_entry(7,1,RGB(31,0,0));
  set_bkg_palette_entry(7,2,RGB(23,23,23));
  set_bkg_palette_entry(7,3,RGB(0,0,31));  

  VBK_REG = 1;

  move_bkg (0,16);
}

// vbk_reg must be 1
void displaysquare(UBYTE posx, UBYTE posy)
{
  temp1 = board[posx][posy];
  set_bkg_tiles (posx,posy,1,1,(unsigned char *)&temp1);
}

// vbk_reg must be 1
void displaypiece (UBYTE posx, UBYTE posy)
{
  temp1 = piece[0];
  set_bkg_tiles (posx,posy,1,1,(unsigned char *)&temp1);

  if (piece[1] != 0)
  {
    temp1 = piece[1];  
    set_bkg_tiles (posx+1,posy,1,1,(unsigned char *)&temp1);
  }
  else
  {
    temp1 = piece[2];
    set_bkg_tiles (posx,posy+1,1,1,(unsigned char *)&temp1);
  }
}

// vbk_reg must be 1
void displaynextpiece ()
{
  temp1 = nextpiece[0];
  set_bkg_tiles (16,9,1,1,(unsigned char *)&temp1);
  temp1 = nextpiece[2];
  set_bkg_tiles (16,10,1,1,(unsigned char *)&temp1);
}

void erasepiece (UBYTE posx, UBYTE posy)
{
  temp1 = 0;
  set_bkg_tiles (posx,posy,1,1,(unsigned char *)&temp1);

  if (piece[1] != 0)
  {
    set_bkg_tiles (posx+1,posy,1,1,(unsigned char *)&temp1);
  }
  else
  {
    set_bkg_tiles (posx,posy+1,1,1,(unsigned char *)&temp1);
  }
}

void erasesquare (UBYTE posx, UBYTE posy)
{
  temp1 = 0;
  set_bkg_tiles (posx,posy,1,1,(unsigned char *)&temp1);
  delay(50);
}

void displayscore( void )
{
  long x;
  VBK_REG = 0;

  /*put the score on the screen */  
  x = (sc_score / 10000) % 10;
  temp1 = (unsigned char) x;
  temp1 = temp1+176;
  set_bkg_tiles (15,4,1,1,(unsigned char *)&temp1);

  x = (sc_score / 1000) % 10;
  temp1 = (unsigned char) x;
  temp1 = temp1+176;
  set_bkg_tiles (16,4,1,1,(unsigned char *)&temp1);

  x = (sc_score / 100) % 10;
  temp1 = (unsigned char) x;
  temp1 = temp1+176;
  set_bkg_tiles (17,4,1,1,(unsigned char *)&temp1);

  x = (sc_score / 10) % 10;
  temp1 = (unsigned char) x;
  temp1 = temp1+176;
  set_bkg_tiles (18,4,1,1,(unsigned char *)&temp1);

  x = (sc_score ) % 10;
  temp1 = (unsigned char) x;
  temp1 = temp1+176;
  set_bkg_tiles (19,4,1,1,(unsigned char *)&temp1);


  VBK_REG = 1;

}

void displayspeed ( void )
{
  VBK_REG = 0;

  /*put the speed */  
  temp1 = (speed /100)% 10;
  temp1 = temp1+176;
  set_bkg_tiles (17,7,1,1,(unsigned char*)&temp1);

  temp1 = (speed /10)% 10;
  temp1 = temp1+176;
  set_bkg_tiles (18,7,1,1,(unsigned char*)&temp1);

  temp1 = speed% 10;
  temp1 = temp1+176;
  set_bkg_tiles (19,7,1,1,(unsigned char*)&temp1);

  VBK_REG = 1;

}

void play_sound (UBYTE s)
{
 // play some different sound
}

void changetempo (UBYTE tempo)
{
  // change the speed the music is playing at
}


