#include <stdio.h>
#include <gb.h>
#include <rand.h>
#include <time.h>
#include "drop.h"
#include "hiscore.h"
#include "tiles\level_data1.h"

#include "tiles\gametiles.c"
#include "tiles\numbers.c"

const char * rom_bank = (const char *)0x7fff;

void music (void);
void resetmusic (void);
void stopmusic (void);

UBYTE music_clock;
UBYTE music_speed;
 
char level_name [20][20] = {
"   Starting Out     ",
"    Mt. Everest     ",
"    Bomb Bunker     ",
"     Bad Mr Frog    ",
"    2 Layer Cake    ",
"    London Bridge   ",
"  Static Electric   ",
"    Ampitheater     ",
"    Buried Alive    ",
"   What You Say!    ",
"     Overhang       ",
"   A Tight Squeese  ",
"  Silver Soup Spoon ",
"    Monkey Rising   ",
"    Blast Radius 7  ",
"     The Armoury    ",
"      Girder        ",
"    Swiss Cheese    ",
"     Pure Hell      ",
"    Maelstorm       "
};

void increase_time (void);
extern unsigned char font[];
extern char level_name[20][20];

UBYTE pics [] = {
4,0,0,5,0,0,6,0,0,
7,0,0,8,0,0,0,9,0,0,
0};

// hiscores
UBYTE word[5][12];
unsigned long int scores[5];

// keep track of how long the has been spent playing
// t_ is for the game
// t2_ is for all the games that have been played

UBYTE t_partsec, t_second, t_minute, t_hour, t_day;
UBYTE t2_partsec, t2_second, t2_minute, t2_hour, t2_day;
UBYTE max_level,start_level;

// these variable can only be used if no other function
// is being called while you are using them
UBYTE temp1, temp2; 
UWORD wtemp1, wtemp2;

UBYTE first_round;
UBYTE sound;

UBYTE show_last_x;
UBYTE show_last_y;

UBYTE show_score_x;
UBYTE show_score_y;
UBYTE show_score_t;


UBYTE show_combo_x;
UBYTE show_combo_y;
UBYTE show_combo_t;

// these are variable to do with player input
UBYTE joy,last_joy;
UBYTE left_initial,right_initial,down_initial;
UBYTE left_secondary,right_secondary,down_secondary;
UBYTE left_timer,right_timer,down_timer;
UBYTE left_rep,right_rep,down_rep;

long display_number; // this is a parameter to displaynumber()
long sc_score, sc_lines, sc_pieces;
UBYTE sc_cheating, sc_gametype, sc_doiwin, sc_bonus_timer, sc_combo, sc_level, sc_stars;
UBYTE sc_difficulty;
UBYTE random_start;

UBYTE piece_pos;
UBYTE piece_block2_color;
UBYTE piece_block1_color;
// 0,1,2
// 3,4,5
// 6,7,8
// the piece has 4 positions 
// position block1 block2
//    0       4      1
//    1       4      5
//    2       4      7
//    3       4      3

UBYTE nextpiece_1; // the next piece that will appear
UBYTE nextpiece_2;

UBYTE list[100][2];

UBYTE board[BOARD_MAX_X][BOARD_MAX_Y];

int nextincrease;
UBYTE linesperlevel;

UBYTE xoffset;
UBYTE nextxpos,nextypos;
UBYTE posx,posy;
UBYTE dead;
UBYTE length;
UBYTE dynatimer;
UBYTE dynax,dynay;
UBYTE extratimer;
UBYTE extrax,extray;
UBYTE countdown;
UBYTE area_box_counter,area_box_timer, area_box_start;

// game options
UBYTE gametype;
UBYTE shownext;
UBYTE startlines;

UBYTE speed;
UBYTE startspeed;
UBYTE maxspeed;
UBYTE resetspeed;
UBYTE speed_increase;

UBYTE linesperlevel;
UBYTE wantstoplay;
UBYTE play_music;
UBYTE sound;
UBYTE cheating;

void (*vblank) (void);           // this is the pointer to the function you 
                                 //want to call during vblank

void vblank_int(void) {          // this is the actual vblank interrupt handler 
  (*vblank)();                   // calls the function you want to run during vblank
}

void do_nothing (void)           // this is the empty vblank function
{

}

void call_stop_music (void)
{
UBYTE rb;
 
 rb = *rom_bank;
 SWITCH_ROM_MBC1 (13);
 stopmusic ();
 SWITCH_ROM_MBC1 (rb);
}

void call_music ( void )
{
  UBYTE rb;
 	music_clock ++;

  if (music_clock >= music_speed)
  {
    music_clock=0;
    rb = *rom_bank;
    SWITCH_ROM_MBC1 (13);
    music ();
    SWITCH_ROM_MBC1 (rb);
  }      
}

/* puts a line of 20 chars onto the window or bkg */
void putln (char str[], UBYTE y, UBYTE wb)
{
  UBYTE c,strx;

  for (strx = 0 ;strx<20;strx++)
  {
    c = str[strx]+128;
    if (wb == 1)
      set_win_tiles (strx,y,1,1,(unsigned char *) &c);
    else
      set_bkg_tiles (strx,y,1,1,(unsigned char *) &c);
  }
}

char p1[] = "       Paused       ";
void pause ( void )
{
  UBYTE tmp1, tmp2;

  vblank = call_music;        // disable the clock while the game is paused

  SHOW_WIN;
  HIDE_SPRITES;
  move_win(7,0);
  VBK_REG = 0;
  putln (p1,7,1);  
  VBK_REG = 1;

  while (joypad() >0);
  while (joypad() <16);
  while (joypad() > 0);

  HIDE_WIN;
  SHOW_SPRITES;

  music_clock = 0;
  vblank = increase_time;        // sets the vblank pointer to work the clock

}

void init_score( void )
{
  if (first_round == 0)
  {
  	sc_score = 0;
	  first_round = 1;
  }

  sc_lines = 0;
  sc_pieces = -1; 
  sc_combo = 0;
	sc_doiwin = NO;
	sc_cheating = 0;
  sc_stars = 0;
}

void set_random_block (UBYTE x, UBYTE y)
{
	temp1 = rand()%NUM_COLORS+1;
  if (sc_difficulty == EVIL) // no matching blocks touch
  {
    while ( (temp1 == board [x-1][y]) || (temp1 == board[x][y-1]) )
    { 
      temp1 ++;
      if (temp1 == NUM_COLORS+1)  
        temp1 = 1;
    }     
  }
  board[x][y] = temp1;
}

void create_quest_board (void)
{
  UBYTE x,y;
	UBYTE t1,t2;
  unsigned char *lp;

  SWITCH_ROM_MBC1 (2); // the level data is in bank 2
  
  lp = level_data1;
  wtemp1 = sc_level-1;

  wtemp1 = wtemp1 * 285;
  lp = lp+wtemp1;
 
  for (y=2;y<BOARD_MAX_Y;y++)
	{
  	for (x=0;x<BOARD_MAX_X;x++)
		{

      t2 = *lp;
      lp++;
       
      if (x==0 || x== BOARD_MAX_X-1) // the sides are empty
        t2 = 0;

      if (t2 == 1) // a random block
      {
        set_random_block (x,y);
  			displaysquare(x,y);
      }
      else if (t2 == 2) // an unbreakable block
      {
	  		board[x][y] = 6;
				displaysquare(x,y);
      }
      else if (t2 == 3) // a star block
      {
				board[x][y] = cSTAR_COLOR;
				displaysquare(x,y);
        sc_stars ++;
      }          
      else // a blank block
				board[x][y]=0;

    }
  }

  SWITCH_ROM_MBC1 (1); // the game over stuff is in bank 1

}

void create_random_board (void)
{
  UBYTE x,y;

	for (x=0;x<BOARD_MAX_X;x++)
	{
		for (y=0;y<BOARD_MAX_Y;y++)
		{
      if (y>BOARD_MAX_Y-startlines-3 && y<BOARD_MAX_Y-2 && x>0 &&
					x<BOARD_MAX_X-1)
			{
        if ( 1 == 1)  // rand()%3 == 1)
			  {
          set_random_block (x,y);
				  displaysquare(x,y);
			  }
			  else
			  {
				  board[x][y]=0;
			  }
      }
      else 
        board[x][y] = 0;
    }
  }
}

void create_board( void )
{
  UBYTE x,y;

  if (cheating&CHEAT_RANDOM_BOARD)
    create_random_board ();
  else if (sc_gametype == QUEST)
    create_quest_board();
}

UBYTE can_rotate_to ( UBYTE pos )
{
  if (pos == 0)
	{
		return board[posx][posy-1];
	}
  if (pos == 1)
	{
		if (posx == BOARD_MAX_X-2)
			return 1;
		return board[posx+1][posy];
	}
  if (pos == 2)
  {
  	//if (posy==BOARD_MAX_Y-3)
	  //	return 1;
	  return board[posx][posy+1];
  }
  if (pos == 3)
	{
    if (posx == 1)
      return 1;
		return board[posx-1][posy];
	}
  return 1;
}

UBYTE canleft ( void )
{
	temp1 = 0;

  if (posx == 1)
    return 1;

	temp1 = board[posx-1][posy];
  
  if (piece_pos == 0)
    temp1 += board[posx-1][posy-1];
  if (piece_pos == 2)
    temp1 += board[posx-1][posy+1];
  if (piece_pos == 3)
  {
    if (posx == 2)
      return 1;
    temp1 += board[posx-2][posy];
  }
	return temp1;
}

UBYTE canright ( void )
{
	temp1 = 0;
  if (posx == BOARD_MAX_X-2)
		return 1;
	
  temp1 = board[posx+1][posy];
  if (piece_pos == 0)
    temp1 += board[posx+1][posy-1];

  if (piece_pos == 1)
  {
    if (posx == BOARD_MAX_X-3)
			return 1;
    temp1 += board[posx+2][posy];
  }
    
  if (piece_pos == 2)
    temp1 += board[posx+1][posy+1];

	return temp1;
}

UBYTE candrop ( void )
{
	temp1 = 0;

	temp1 = board[posx][posy+1];

  if (piece_pos == 1)
    temp1 += board[posx+1][posy+1];
  if (piece_pos == 2)
    temp1 += board[posx][posy+2];
  if (piece_pos == 3)
    temp1 += board[posx-1][posy+1];

	return temp1;

}

UBYTE inlist (UBYTE x, UBYTE y, UBYTE len)
/* 0 = in list, 1= not in list */
{
	int temp1;
	for (temp1 = 0 ; temp1 <= len ; temp1++)
	{
		if ((list[temp1][0] == x) && (list[temp1][1] == y))
			return 0;
	}
	return 1;
}

void initlist( void )
{
	for (temp1 = 0 ; temp1 < 100 ; temp1++)
	{
		list[temp1][0]=0;
		list[temp1][1]=0;
	}
}

UWORD checkpos (UBYTE posx,UBYTE posy,UBYTE length)
{
	UBYTE c,n;
	UBYTE color;
	UBYTE x,y;
	UWORD sc = 0;

	color = board[posx][posy];
	c=n=0;

	if (color == 0)
		return 0;

	if (color == 8) // dynamite
	{
		BYTE x1;
		BYTE y1;
		for ( y1 = -1 ; y1 < 2 ; y1++)
			for (x1 = -1 ; x1 < 2 ; x1++)
				board[posx+x1][posy+y1] = 0;

		//put_explosion(posx,posy);
		if (sound)
			play_sound(1);

		dynax = posx;
		dynay = posy;
		dynatimer = 3;
		return 0;
	}

	list[n][0]=posx;
	list[n][1]=posy;

	while (c <= n)
	{
		x = list[c][0];
		y = list[c][1];

		if (board[x-1][y] == color || board[x-1][y] == cSTAR_COLOR)
		{
			if (inlist(x-1,y,n)==1)
			{
				n++;
				list[n][0]=x-1;
				list[n][1]=y;
			}
		}
		if (board[x+1][y] == color || board[x+1][y] == cSTAR_COLOR)
		{
			if (inlist(x+1,y,n)==1)
			{
				n++;
				list[n][0]=x+1;
				list[n][1]=y;
			}
		}
		if (board[x][y-1] == color || board[x][y-1] == cSTAR_COLOR)
		{
			if (inlist(x,y-1,n)==1)
			{
				n++;
				list[n][0]=x;
				list[n][1]=y-1;
			}
		}
		if (board[x][y+1] == color || board[x][y+1] == cSTAR_COLOR)
		{
			if (inlist(x,y+1,n)==1)
			{
				n++;
				list[n][0]=x;
				list[n][1]=y+1;
			}
		}
		c++;
	}
	if (n>length)
	{
		c=n;
		delay(20);

		for (n=0;c>=n;n++)
		{
			sound_pop();
			x=list[n][0];
			y=list[n][1];
			erasesquare(x,y);
			sc = sc+n+1;
      if (board[x][y] == cSTAR_COLOR)
      {
        // the player got a quest star
        sc = sc + 40;  // 40 bonus points for a star
        sc_stars --;
        if (sc_stars == 0)
        {
          dead = 1;
          sc_doiwin = 1;
        }
      }
			board[x][y]=0;
		}
    show_last_x = x;
    show_last_y = y;
		return sc;
	}

	return 0;

}

int piecetoboard (int x, int y,int length)
{
	UWORD sc1=0;
	UWORD sc2=0;
	UBYTE got_a_line = NO;
	UWORD total = 0;

	board[x][y] = piece_block1_color;

  if (piece_pos == 0)
  {
    board[x][y-1] = piece_block2_color;
  	sc2 = checkpos(x,y-1,length);
  }
  if (piece_pos == 1)
  {
    board[x+1][y] = piece_block2_color;
  	sc2 = checkpos(x+1,y,length);
  }
  if (piece_pos == 2)
  {
    board[x][y+1] = piece_block2_color;
  	sc2 = checkpos(x,y+1,length);
  }
  if (piece_pos == 3)
  {
    board[x-1][y] = piece_block2_color;
  	sc2 = checkpos(x-1,y,length);
  }

	sc1 = checkpos(x,y,length);

	if (sc1>0)
	{
		sc_lines++;
		got_a_line=YES;
	}

	if (sc2>0)
	{
		sc_lines++;
		got_a_line=YES;
	}

	total = sc1+sc2;

  // bonus points for getting two lines at once
	if (sc1>0 && sc2>0)
	{
		total=total*4;
  	//print_str("Two Lines * 4",10,160,100,4,0);
		//sc_bonus_timer=35;
	}

  // bonus points if show_next is off
	if (!shownext)
		total = total + (total>>2);
  
  // bonus points for getting 2 or more lines in a row
  if (sc1>0 || sc2>0)
  {
    sc_combo ++;

    // put the combo display up
    show_combo_x = 140;
    show_combo_y = 140;
 
    set_sprite_tile (5,11);
    temp1 = sc_combo+1;
    if (temp1 > 4)
      temp1 = 4;
    set_sprite_tile (6,temp1);
    show_combo();
  
    // if this is a combo, then add the bonus points
    if (sc_combo > 1)
    {
      // if this is 2nd or 3rd line X2
      if (sc_combo==2)
        total = total + total;
      else if (sc_combo == 3)
        total = total + total + total;
      else // 4th line and above X4
        total = total<<2;
    }
  }
  else
  {
    // remove the combo display
    sc_combo = 0;
    show_combo_y = 200;
    show_combo();
  }

	sc_score +=total;

	if (total >0)
	{
    // put the total up on the screen
    
    show_score_x = show_last_x*8;
    if (total < 1000)
    {
      show_score_x = show_score_x - 5;
    }
    show_score_y = show_last_y*8;
    show_score_t = 61;

    // get the 1000's
    temp1 = 0;
    while ( total > 999)
    {
      total -= 1000;
      temp1++;
    }
    if (temp1 == 0)
      temp1 = 10;
    set_sprite_tile(0,temp1);
  
    temp1 = 0;
    while ( total > 99)
    {
      total -= 100;
      temp1++;
    }
    if (temp1 == 0)
      temp1 = 10;
    set_sprite_tile(1,temp1);

    temp1 = 0;
  	while ( total > 9)
    {      
      total -= 10;
      temp1++;
    }
    set_sprite_tile(2,temp1);

    temp1 = total;
    set_sprite_tile(3,temp1);

    show_score ();
 	}

  if (got_a_line)
  {
    display_number = sc_lines;
    displaynumber (13);
  }
	return got_a_line;
}

void newpiece (void)
{
	nextpiece_1 = rand()%NUM_COLORS+1;
	nextpiece_2 = rand()%NUM_COLORS+1;

  sc_pieces ++;
  display_number = sc_pieces;
  displaynumber (16);
}

void trydown (void)
{
	if (candrop() == 0)
	{
		erasepiece(posx,posy);
		posy++;
		displaypiece(posx,posy);
    countdown = speed +1;
	}
  else
  {
		countdown = speed +1;
		piecefall();
    down_rep = 2;
    // give the player lots of time before the next piece drops
    down_timer = down_secondary+1; 
  }
}

void player_input (void)
{
  joy = joypad();

	if (joy & J_LEFT)
	{
		if (!(last_joy & J_LEFT))
    {
      if (canleft() == 0)
		  {
				erasepiece(posx,posy);
				posx--;
				displaypiece(posx,posy);
		  }
      left_timer = 0;
      left_rep = 1;
	  }
    else 
    {
      if (left_rep == 1) 
      {
        left_timer++;
        if (left_timer == left_initial)
        {
          left_timer = 0;
          left_rep = 2;
          if (canleft() == 0)
		      {
				    erasepiece(posx,posy);
				    posx--;
				    displaypiece(posx,posy);
		      }
        } 
      }
      else // left_rep = 2 
      {
        left_timer++;
        if (left_timer == left_secondary)
        {
          left_timer = 0;
          if (canleft() == 0)
		      {
				    erasepiece(posx,posy);
				    posx--;
				    displaypiece(posx,posy);
		      }
        } 
      }
    }
  }

	if (joy & J_RIGHT) 
	{
    if (!(last_joy & J_RIGHT))
    {
  		if (canright() == 0)
	  	{
		  	erasepiece(posx,posy);
			  posx++;
			  displaypiece(posx,posy);
		  }
      right_rep = 1;
      right_timer = 0;
	  }
    else
    {
      if (right_rep == 1)
      {
        right_timer++;
        if (right_timer == right_initial)
        {
          right_timer = 0;
          right_rep = 2;
          if (canright() == 0)
		      {
				    erasepiece(posx,posy);
				    posx++;
				    displaypiece(posx,posy);
		      }
        }
      }
      else
      {
        right_timer++;
        if (right_timer == right_secondary)
        {
          right_timer = 0;
          if (canright() == 0)
		      {
				    erasepiece(posx,posy);
				    posx++;
				    displaypiece(posx,posy);
		      }
        }
      }
    }
  }

  if ((joy & J_SELECT) && !(last_joy & J_SELECT))
  {
    temp1 = piece_block1_color;
    piece_block1_color = piece_block2_color;
    piece_block2_color = temp1;
  	displaypiece(posx,posy);
  }

  if ((joy & J_A) && !(last_joy & J_A))
	{
    temp1 = (piece_pos + 3) & 3;
	  if (can_rotate_to (temp1) == 0)
	  {
			erasepiece(posx,posy);
      piece_pos = (piece_pos + 3) & 3;
			displaypiece(posx,posy);
		}
	}
  
  if ((joy & J_B) && !(last_joy & J_B))
	{
    temp1 = (piece_pos + 1) & 3;
	  if (can_rotate_to (temp1) == 0)
	  {
			erasepiece(posx,posy);
      piece_pos = (piece_pos + 1) & 3;
			displaypiece(posx,posy);
		}
	}

  if ((joy & J_START) && !(last_joy & J_START))
  {
    pause ();
  }
  
  if (joy & J_DOWN)
	{
    if (!(last_joy & J_DOWN))
    {
      trydown();
      down_timer = 0;
      down_rep = 1;
    }
    else
    {
      if (down_rep == 1)
      {
        down_timer ++;
        if (down_timer == down_initial)
        {
          trydown();
          down_rep = 2;
          down_timer = 0;
        }
      }
      else
      {
        down_timer ++;
        if (down_timer == down_secondary)
        {
          trydown();
          down_timer = 0;
        }
      }
    }
	}

  last_joy = joy;

}

void piecefall ( void )
{
	UBYTE did_score;

	erasepiece(posx, posy);
	if (candrop() == 0)
	{
		posy++;
		displaypiece(posx, posy);
	}
	else
	{
		displaypiece(posx, posy);
		sound_click();
    did_score = piecetoboard(posx,posy,length);
		if (did_score == YES)
		{
			if (sc_gametype == FAST && sc_lines>49)
			{
				sc_doiwin=YES;
				dead = YES;
			}
			if (sc_lines >= nextincrease)
			{
				speed = speed - speed_increase;
				nextincrease += linesperlevel;

				if (speed < maxspeed)
				{
					speed = resetspeed;
          if (sc_difficulty > EASY)
      			length++;
				}
        /*
				if (play_music)
				{
					if (speed == resetspeed)
					{
						ChangeTempo(3);
					}
					else if (speed ==5)
					{
						ChangeTempo(2);
					}
					else if (speed ==3)
					{
						ChangeTempo(1);
					}
				}
        */
 
        display_number = speed;
				displaynumber (10);
			}
      
      display_number = sc_score;
			displaynumber (7);

		}

		posx = 7;
		posy = 2;
 
    piece_pos = 2;
    piece_block1_color = nextpiece_1;
    piece_block2_color = nextpiece_2;
	
  	newpiece();
		if (shownext==YES)
			displaynextpiece();
		
    if ((board[7][3]!=0) || (board[7][2]!=0))
			dead=YES;
		displaypiece(posx, posy);
	}	
}

/*
void extra_piece ()
{
	int p = b->posx;
	int c = BOARD_MAX_Y-3;

	while (p == b->posx)
		p = random(BOARD_MAX_X-4)+2;

	while (b->a[p][c] !=0)
		c--;

	if (c==0 && (b->gameops->issoundon== YES))
		play_sound(1);

	if (c!=0)
	{
		b->a[p][c] = random(NUM_COLORS-1)+1;
		//put_explosion(p,c,b->xoffset);
		displaysquare(b,p,c,b->xoffset);

		b->extrax = p;
		b->extray = c;
	}
}
*/

void update_board ()
{

  // this is to change the face of one of the pieces
  // not implemented in the gameboy version
	// displaysquare(b,random(BOARD_MAX_X),random(BOARD_MAX_Y),b->xoffset);

}

void update_sides (void)
{
  // the sides of the board scroll
  area_box_timer ++;
  if (area_box_timer == 20)
  {
    area_box_timer = 0;
    area_box_counter++;
    if (area_box_counter == area_box_start+4)
      area_box_counter = area_box_start;
    VBK_REG = 0;
    wtemp1 = area_box_counter;
    wtemp1 = wtemp1 << 4;
    set_bkg_data (9,1,&gametiles[wtemp1]);      
    VBK_REG = 1;
  }
}


// this function initializes the variables that are for 1 round only
// i.e. need to be re initialize before each level
void init_round_variables ()
{
  if (random_start)
    initrand (sc_level);

  if (sc_difficulty == EASY)
  {
    startspeed = 80;
    maxspeed = 50;
    resetspeed = 80;
    speed_increase = 5;
    linesperlevel = 7;
    shownext = YES;
  }
  if (sc_difficulty == MEDIUM)
  {
    startspeed = 60;
    maxspeed = 30;
    resetspeed = 60;
    speed_increase = 5;
    linesperlevel = 6;
    shownext = YES;
  }
  else if (sc_difficulty == HARD || sc_difficulty == EVIL)
  {
    startspeed = 40;
    maxspeed = 10;
    resetspeed = 40;
    speed_increase = 5;
    linesperlevel = 6;
    shownext = NO;
  }

  area_box_start = 9 + ((rand()%5)*4);
  area_box_counter = area_box_start;
  area_box_timer = 0;

  left_timer = right_timer = down_timer = 0;
  left_initial = right_initial = 20;
  down_initial = 15;
  left_secondary = right_secondary = down_secondary = 6;
  left_rep = right_rep = down_rep = 0;

	length = 2;
	nextincrease = linesperlevel;
	speed = startspeed;
	dead = NO;
	posx = 7;
	posy = 2;
	dynatimer = 0;
	dynax = dynay = 0;

  show_score_x = show_score_y = show_score_t = 0;
  show_combo_x = show_combo_y = show_combo_t = 0;

}

void init_board ()
{

	init_score();

  init_graphics ();

	newpiece();
  piece_pos = 2;
  piece_block1_color = nextpiece_1;
  piece_block2_color = nextpiece_2;
	
  newpiece();

  create_board();

}

void play ()
{
	UBYTE loops = 0;

  init_board ();

	initrand ((UWORD) clock());
  countdown = speed+1;

  display_number = speed;
	displaynumber (10);

  display_number = sc_score;
	displaynumber (7);

  display_number = sc_lines;
  displaynumber (13);

	displaypiece (posx,posy);

	if (shownext)
	{
		displaynextpiece();
	}


  vblank = increase_time;        

	while (dead==NO)
	{
		loops ++;
	
  	player_input ();

    wait_vbl_done();
		// erase score board
  	update_board();

    update_sides();

		loops=0;
		countdown--;
  	if (countdown == 0)
		{
			countdown = speed +1;
			piecefall();
		}

    // if a score is being shown then count that down
    if (show_score_t > 0)
    {
      show_score_t --;
      if (show_score_t == 0)
      {
        show_score_y = 200;
        show_score();
      }
      else if (show_score_t % 10 == 0)
      {
        if (joy & J_LEFT)
          show_score_x --;
        if (joy & J_RIGHT)
          show_score_x ++;

        show_score_y--;
        show_score();
      }
    }
	}

  vblank = call_music;        // sets the vblank pointer to null

  // hide the sprites around the center piece
  move_sprite (8,200,200);
  move_sprite (9,200,200);
 
  // remove the combo display
  sc_combo = 0;
  show_combo_y = 200;
  show_combo();
 
}

void show_hicolor_pic (UBYTE input)
{ 
  UBYTE x;
  void (*t_vbl) (void);

  t_vbl = vblank;
  vblank = do_nothing;
  call_stop_music();

  x = input;
  SwitchSpeed(); // double speed!
  DisplayHiclr(x, J_A|J_B);

  SWITCH_ROM_MBC1 (1); 

  vblank = t_vbl;
  VBK_REG = 0;
  set_bkg_data (0,2,gametiles); // set tile 0 to empty :-)
  empty_screen();
  // load the font data
  set_win_data ((UBYTE)-128,128,font);
  SwitchSpeed(); // single speed!
  while (joypad());
  
}

void show_level_details (void)
{
  empty_screen();

  if ( pics [sc_level] != 0 )
  show_hicolor_pic (pics [sc_level]);

  SWITCH_ROM_MBC1 (2); // the level_data is in bank 2
  
  if( _cpu==CGB_TYPE )
  {
    /* set the title palettes */
    set_bkg_palette_entry(0,0,RGB(0,0,0));
  	set_bkg_palette_entry(0,1,RGB(21,21,21));
  	set_bkg_palette_entry(0,2,RGB(14,14,14));
    set_bkg_palette_entry(0,3,RGB(31,31,31));
  }
  
  putln (level_name[sc_level],8,0);

  SWITCH_ROM_MBC1 (1); 

  wait_for_start();
  empty_screen();

}

// This initializes the variables that are for the whole game
void init_game_variables ( void )
{

  if (sc_gametype == QUEST)
  {
    cheating = 0;
  }
  else
  {
    startlines = 10;
    cheating = CHEAT_RANDOM_BOARD;
  }
  
  // This variable decides if all the blocks in the puzzle levels will be the same 
  // type every time you play a level 
  random_start = NO;
  
  // Is the sound on or not
  sound = YES;

  // music speed
  music_speed = 7;
  
  SWITCH_ROM_MBC1 (13); 
  initmusic ();
  SWITCH_ROM_MBC1 (1); 
  
  // zero the time counter
  t_partsec = t_second = t_minute = t_hour = t_day = 0;
}

void run_game ( void )
{

  first_round = 0;
  init_game_variables ();

  if (sc_gametype == FAST)
  {
    sc_level = 1;
    init_round_variables ();
    play ();
    empty_board ();
  }
  else if (sc_gametype == QUEST)
  {
    sc_doiwin = 1;
    sc_level = start_level;
    while (sc_doiwin == 1 && sc_level <20)
    {
      show_level_details ();

      sc_doiwin = 0;
      sc_level++;
      if (sc_level > max_level)
      {
        max_level = sc_level;
        save_hiscore (0);
      }

      init_round_variables ();
      play();
      empty_board ();
    }
    if (sc_doiwin == 0)
    { 
      empty_screen ();
      show_hicolor_pic (12);
    }
    else
    {
      empty_screen();
      show_hicolor_pic (11);
    }
  }
}

void main ( void )
{
  UBYTE x;
  UBYTE rc;

  sc_difficulty = EASY;
  sc_gametype = QUEST;
  start_level = 0;

  music_speed = 8;
  SWITCH_ROM_MBC1 (13); 
  initmusic ();
  SWITCH_ROM_MBC1 (1); 
  vblank = call_music;        // sets the vblank pointer to null
  add_vbl(vblank_int);          // adds the vblank interrupt handler
  enable_interrupts();          // enables interrupts
  set_interrupts(VBL_IFLAG);    //turns the vblank interrupt flag on

  // turn on the speakers 
  NR52_REG = 0xF8U;
  NR51_REG = 0x00U;
  NR50_REG = 0xFFU;
 
  load_hiscore(0);

  // load the font data and check for color gameboy
  set_win_data ((UBYTE)-128,128,font);
  set_bkg_data (1,1,font);
  check_cgb ();

  show_hicolor_pic (3);
  
  // load the font data
  set_win_data ((UBYTE)-128,128,font);

  set_bkg_data (1,1,font);

  while (1 == 1) 
	{
  	show_hicolor_pic(10);
    menu ();
    run_game ();

    vblank = do_nothing;        // sets the vblank pointer to null
    call_stop_music();

		gameover ();

    rc = add_new_score(sc_score);
    show_scores(rc);
    save_hiscore(0);
	}
}


static const unsigned char cEMPTY[] = 
{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; 
/* an empty line for the background */

static const unsigned char GAME_SCREEN_PAL[] = 
{ 7,0,0,0,0,0,0,0,0,0,0,0,0,0,39,7,7,7,7,7}; 

static const unsigned char GAME_SCREEN[] = 
{ 9,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0}; 

static const unsigned char GAME_WIN_PAL[] = 
{ 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7}; 

void empty_screen (void)
{
 
  HIDE_BKG;
  HIDE_SPRITES;

  VBK_REG = 0;

  for (temp1=0; temp1<40; temp1++)
  {
    move_sprite(temp1,0,200);
    set_sprite_prop (temp1,0);
  }

  for (temp1=0; temp1<20; temp1++)
  {
    set_bkg_tiles (0,temp1,20,1,(unsigned char *) &cEMPTY[0]);   
    set_win_tiles (0,temp1,20,1,(unsigned char *) &cEMPTY[0]);   

    VBK_REG = 1;
    set_bkg_tiles (0,temp1,20,1,(unsigned char *) &cEMPTY[0]);   
    set_win_tiles (0,temp1,20,1,(unsigned char *) &GAME_WIN_PAL[0]);   
    VBK_REG = 0;
  }

  move_bkg (0,0);
  
  SHOW_BKG;
  SHOW_SPRITES;
  DISPLAY_ON;
}

char GS1[] = "Next ";
char GS2[] = "Score";
char GS3[] = "Speed";
char GS4[] = "Lines";
char GS5[] = "Piece";

void init_graphics (void)
{
  empty_screen ();

  set_bkg_data (0,29,gametiles);

  wtemp1 = area_box_counter;
  wtemp1 = wtemp1 << 4;
  set_bkg_data (9,1,&gametiles[wtemp1]);      

  set_sprite_data (0,13,numbers);

  temp2 = area_box_start;

  for (temp1=0; temp1<20; temp1++)
  {
    set_bkg_tiles (0,temp1,20,1,(unsigned char *) &GAME_SCREEN[0]);
    set_win_tiles (0,temp1,20,1,(unsigned char *) &cEMPTY[0]);   

    VBK_REG = 1;
    set_bkg_tiles (0,temp1,20,1,(unsigned char *) &GAME_SCREEN_PAL[0]);   
    VBK_REG = 0;
  }
  
  if (shownext) // only put up the next if the next is being shown.
  for (temp1 = 0; temp1 < 5 ; temp1++)
  {
    temp2 = GS1[temp1];
    temp2 = temp2 + 128;
    set_bkg_tiles (15+temp1,2,1,1,(unsigned char *) &temp2);
  }

  for (temp1 = 0; temp1 < 5 ; temp1++)
  {
    temp2 = GS2[temp1];
    temp2 = temp2 + 128;
    set_bkg_tiles (15+temp1,6,1,1,(unsigned char *) &temp2);
  }
  for (temp1 = 0; temp1 < 5 ; temp1++)
  {
    temp2 = GS3[temp1];
    temp2 = temp2 + 128;
    set_bkg_tiles (15+temp1,9,1,1,(unsigned char *) &temp2);
  }
  for (temp1 = 0; temp1 < 5 ; temp1++)
  {
    temp2 = GS4[temp1];
    temp2 = temp2 + 128;
    set_bkg_tiles (15+temp1,12,1,1,(unsigned char *) &temp2);
  }
  for (temp1 = 0; temp1 < 5 ; temp1++)
  {
    temp2 = GS5[temp1];
    temp2 = temp2 + 128;
    set_bkg_tiles (15+temp1,15,1,1,(unsigned char *) &temp2);
  }

  // the sprite palette
  set_sprite_palette_entry(0,0,RGB(0,0,0)); 
  set_sprite_palette_entry(0,1,RGB(31,31,0)); 
  set_sprite_palette_entry(0,2,RGB(31,0,0)); 
  set_sprite_palette_entry(0,3,RGB(0,0,0)); 

  // the score sprites
  set_sprite_prop (0,0);
  set_sprite_prop (1,0);
  set_sprite_prop (2,0);
  set_sprite_prop (3,0);

  // the combo sprites
  set_sprite_prop (5,0);
  set_sprite_prop (6,0);

  // the piece sprites
  set_sprite_prop (8,0);
  set_sprite_prop (9,96);
  set_sprite_tile (8,12);
  set_sprite_tile (9,12);

  //  blank
  set_bkg_palette_entry(0,0,RGB(0,0,0)); 

  //  red
  set_bkg_palette_entry(1,0,RGB(0,0,0)); 
  set_bkg_palette_entry(1,1,RGB(31,0,0)); 
  set_bkg_palette_entry(1,2,RGB(0,0,0)); 
  set_bkg_palette_entry(1,3,RGB(0,0,0)); 

  // green
  set_bkg_palette_entry(2,0,RGB(0,0,0)); 
  set_bkg_palette_entry(2,1,RGB(0,31,0)); 
  set_bkg_palette_entry(2,2,RGB(0,0,0)); 
  set_bkg_palette_entry(2,3,RGB(0,0,0)); 

  // blue
  set_bkg_palette_entry(3,0,RGB(0,0,0)); 
  set_bkg_palette_entry(3,1,RGB(0,0,31)); 
  set_bkg_palette_entry(3,2,RGB(0,0,0)); 
  set_bkg_palette_entry(3,3,RGB(31,31,0)); 

  // grey
  set_bkg_palette_entry(4,0,RGB(0,0,0)); 
  set_bkg_palette_entry(4,1,RGB(10,10,10)); 
  set_bkg_palette_entry(4,2,RGB(0,0,0)); 
  set_bkg_palette_entry(4,3,RGB(0,0,0)); 

  // yellow
  set_bkg_palette_entry(5,0,RGB(0,0,0)); 
  set_bkg_palette_entry(5,1,RGB(31,31,0)); 
  set_bkg_palette_entry(5,2,RGB(0,0,0)); 
  set_bkg_palette_entry(5,3,RGB(0,0,0)); 

  // Unbreakable
  set_bkg_palette_entry(6,0,RGB(0,0,0)); 
  set_bkg_palette_entry(6,1,RGB(31,31,0)); 
  set_bkg_palette_entry(6,2,RGB(0,0,0)); 
  set_bkg_palette_entry(6,3,RGB(0,0,0)); 

  // score text and shit
  set_bkg_palette_entry(7,0,RGB(0,0,0)); 
  set_bkg_palette_entry(7,1,RGB(31,0,0));
  set_bkg_palette_entry(7,2,RGB(31,31,0));
  set_bkg_palette_entry(7,3,RGB(31,31,31));  

  VBK_REG = 1;

  move_bkg (0,16);
}

// vbk_reg must be 1
void displaysquare (UBYTE posx, UBYTE posy)
{
  temp1 = board[posx][posy];

  set_bkg_tiles (posx,posy,1,1,(unsigned char *)&temp1);
  VBK_REG = 0;
  set_bkg_tiles (posx,posy,1,1,(unsigned char *)&temp1);
  VBK_REG = 1;
}

// vbk_reg must be 1
void displaypiece (UBYTE posx, UBYTE posy)
{
  move_sprite(8, ((posx+1) << 3)-3, (posy <<3)-3);
  move_sprite(9, ((posx+1) << 3)+3, (posy <<3)+3);

  temp1 = piece_block1_color;
  set_bkg_tiles (posx,posy,1,1,(unsigned char *)&temp1);
  VBK_REG = 0;
  set_bkg_tiles (posx,posy,1,1,(unsigned char *)&temp1);
  VBK_REG = 1;

  temp1 = piece_block2_color;  
  if (piece_pos == 0)
  {
    set_bkg_tiles (posx,posy-1,1,1,(unsigned char *)&temp1);
    VBK_REG = 0;
    set_bkg_tiles (posx,posy-1,1,1,(unsigned char *)&temp1);
    VBK_REG = 1;
  }
  if (piece_pos == 1)
  {
    set_bkg_tiles (posx+1,posy,1,1,(unsigned char *)&temp1);
    VBK_REG = 0;
    set_bkg_tiles (posx+1,posy,1,1,(unsigned char *)&temp1);
    VBK_REG = 1;
  }
  if (piece_pos == 2)
  {
    set_bkg_tiles (posx,posy+1,1,1,(unsigned char *)&temp1);
    VBK_REG = 0;
    set_bkg_tiles (posx,posy+1,1,1,(unsigned char *)&temp1);
    VBK_REG = 1;
  }
  if (piece_pos == 3)
  {
    set_bkg_tiles (posx-1,posy,1,1,(unsigned char *)&temp1);
    VBK_REG = 0;
    set_bkg_tiles (posx-1,posy,1,1,(unsigned char *)&temp1);
    VBK_REG = 1;
  }
}

// vbk_reg must be 1
void displaynextpiece ()
{
  temp1 = nextpiece_1;
  set_bkg_tiles (17,3,1,1,(unsigned char *)&temp1);
  temp1 = nextpiece_2;
  set_bkg_tiles (17,4,1,1,(unsigned char *)&temp1);
  VBK_REG = 0;

  temp1 = nextpiece_1;
  set_bkg_tiles (17,3,1,1,(unsigned char *)&temp1);
  temp1 = nextpiece_2;
  set_bkg_tiles (17,4,1,1,(unsigned char *)&temp1);
  VBK_REG = 1;

}

// erasepiece only sets the tile to 0, which is a blank tile in all palettes
// saves a bit of time
void erasepiece (UBYTE posx, UBYTE posy)
{
  temp1 = 0;
  VBK_REG = 0;
  set_bkg_tiles (posx,posy,1,1,(unsigned char *)&temp1);

  if (piece_pos == 0)
  {
    set_bkg_tiles (posx,posy-1,1,1,(unsigned char *)&temp1);
  }
  if (piece_pos == 1)
  {
    set_bkg_tiles (posx+1,posy,1,1,(unsigned char *)&temp1);
  }
  if (piece_pos == 2)
  {
    set_bkg_tiles (posx,posy+1,1,1,(unsigned char *)&temp1);
  }
  if (piece_pos == 3)
  {
    set_bkg_tiles (posx-1,posy,1,1,(unsigned char *)&temp1);
  }
  VBK_REG = 1;
}

void erasesquare (UBYTE posx, UBYTE posy)
{

  VBK_REG = 0;
  temp1 = 0;
  set_bkg_tiles (posx,posy,1,1,(unsigned char *)&temp1);
  delay(50);
  // this delay is very bad

  VBK_REG = 1;
}

// puts a floating score on the screen at the show_score pos
void show_score (void)
{
  move_sprite (0,show_score_x,show_score_y);
  move_sprite (1,show_score_x+5,show_score_y);
  move_sprite (2,show_score_x+10,show_score_y);
  move_sprite (3,show_score_x+15,show_score_y);
}

// puts the combo display on the screen
void show_combo (void)
{
  move_sprite (5,show_combo_x,show_combo_y);
  move_sprite (6,show_combo_x+6,show_combo_y);
}

void displaynumber ( UBYTE y )
{
  long x;
  VBK_REG = 0;

  /*put the number on the screen */  
  if (display_number >9999) 
  {
    x = (display_number / 10000) % 10;
    temp1 = (unsigned char) x;
    temp1 = temp1+176;
  }
  else 
    temp1 = 160;
  set_bkg_tiles (15,y,1,1,(unsigned char *)&temp1);

  if (display_number > 999)
  {
    x = (display_number / 1000) % 10;
    temp1 = (unsigned char) x;
    temp1 = temp1+176;
  }
  else 
    temp1 = 160;
  set_bkg_tiles (16,y,1,1,(unsigned char *)&temp1);
  
  if (display_number > 99)
  {
    x = (display_number / 100) % 10;
    temp1 = (unsigned char) x;
    temp1 = temp1+176;
  }
  else 
    temp1 = 160;
  set_bkg_tiles (17,y,1,1,(unsigned char *)&temp1);

  if (display_number > 9)
  {
    x = (display_number / 10) % 10;
    temp1 = (unsigned char) x;
    temp1 = temp1+176;
  }
  else 
    temp1 = 160;
  set_bkg_tiles (18,y,1,1,(unsigned char *)&temp1);
    
  x = (display_number ) % 10;
  temp1 = (unsigned char) x;
  temp1 = temp1+176;
  set_bkg_tiles (19,y,1,1,(unsigned char *)&temp1);

  VBK_REG = 1;

}

void play_sound (UBYTE s)
{
 // play some different sound
}

void sound_click (void)
{
  //if (sound==YES)
  {
    NR41_REG = 0x37U;
    NR42_REG = 0xF8U;
    NR43_REG = 0x07U;
    NR44_REG = 0xC0U;
    NR51_REG = 0xF7;
  }
} 

void sound_pop (void)
{
  //if (sound==YES)
  {
    NR21_REG = 0x7AU;
    NR22_REG = 0xF8U;
    NR23_REG = 0xFFU;
    NR24_REG = 0xC6U;
  }
} 

void changetempo (UBYTE tempo)
{
  // change the speed the music is playing at
}

UBYTE wait_for_button (void)
{
  UBYTE j;

  j = 0;

  while (joypad() != 0);
  // wait for the user to press a button
  while (j < 16)
    j=joypad();
  // wait for the user to release the button
  while (joypad() != 0);

  return j;
}


void increase_time (void)
{

  t_partsec ++;
  if (t_partsec == 60)
  { 
    t_partsec = 0;
    t_second ++;
  }
  if (t_second == 60)
  {
    t_second = 0;
    t_minute ++;
  }
  if (t_minute == 60)
  {
    t_minute = 0;
    t_hour ++;
  }
  if (t_hour == 24)
  {
    t_hour = 0;
    t_day ++;
  }

    call_music();

}

